UNIT uFenster;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, 
     Forms, Dialogs, StdCtrls, mtZufallsfelderzeuger, mtSortiermaschine,mtRipplesort, mtBubblesort, mtMergesort;

type
  tfeld=array [0..100000] of longint; //tfeld fr das zu sortierende Feld

type
   TFrmSortieren = CLASS(TForm)

     // published Attribute
        BtnEnde : TButton;
        BtnErzeugen : TButton;
        BtnListesortiertAnzeigen : TButton;
        BtnListeunsortiertAnzeigen : TButton;
        BtnSortieren : TButton;
        CBxZufallszahlen : TComboBox;
        GBxListesortiert : TGroupBox;
        GBxListeunsortiert : TGroupBox;
        GBxZeitbedarf : TGroupBox;
        LblAnzahl : TLabel;
        LblHinweissortiert : TLabel;
        LblHinweisunsortiert : TLabel;
        LblOK : TLabel;
        LblZeitbedarf : TLabel;
        MmoFeldsortiert : TMemo;
        MmoFeldunsortiert : TMemo;
        GbxVerfahren: TGroupBox;
        RBBubblesort: TRadioButton;
        RBRipplesort: TRadioButton;
        RBMergeSort: TRadioButton;

     // published Methoden
        procedure BtnEndeClick(Sender:TObject);
        procedure BtnErzeugenClick(Sender:TObject);
        procedure BtnListesortiertAnzeigenClick(Sender:TObject);
        procedure BtnListeunsortiertAnzeigenClick(Sender:TObject);
        procedure BtnSortierenClick(Sender:TObject);
        procedure CBxZufallszahlenChange(Sender:TObject);
        procedure FormCreate(Sender:TObject);

     // weitere Attribute
     private
        sortiermaschine:Tsortiermaschine; //hat Sortiermaschine allgemein
        ripplesortmaschine : Tripplesort; //hat Ripplesortmaschine
        bubblesortmaschine:Tbubblesort;   //hat Bubblesortmaschine
        mergesortmaschine:TMergesort;     //hat Mergesortmaschine
        zufallsfelderzeuger : TZufallsfelderzeuger;

     //Objektbeziehungen:
        // hatTSortiermaschine : TSortiermaschine;
        // hatTZufallsfelderzeuger : TZufallsfelderzeuger;
   end;

var
  FrmSortieren:  TFrmSortieren;
  feld:tfeld;
implementation

{$R *.DFM}

//+---------------------------------------------------------------------
//|         TFrmSortieren: Methodendefinition 
//+---------------------------------------------------------------------

//-------- BtnEndeClick (published) ---------------------------------------
//----Reaktion auf Programmendebutton---------------------------------------
procedure TFrmSortieren.BtnEndeClick(Sender:TObject);
begin
  mergesortmaschine.gibfrei;
  bubblesortmaschine.gibfrei;
  ripplesortmaschine.gibfrei;
  zufallsfelderzeuger.gibfrei;
  close;
end;

//-------- BtnErzeugenClick (published) -----------------------------------
//----Reaktion auf Zefdlerzeugebutton---------------------------------------
procedure TFrmSortieren.BtnErzeugenClick(Sender:TObject);
begin
  LblZeitbedarf.Caption:='';
  BtnListesortiertAnzeigen.Visible:=False;
  zufallsfelderzeuger.SetzeZufallsfeldlaenge(StrToInt(CBxZufallszahlen.Text));
  zufallsfelderzeuger.erzeugeZufallsfeld;
  if zufallsfelderzeuger.GibZufallsfeldlaenge < 5001
  then BtnListeunsortiertAnzeigen.Visible:=true;
  LblOK.Caption:='OK';
  BtnSortieren.Visible:=true;
end;

//-------- BtnListesortiertAnzeigenClick (published) ----------------------
//----Reaktion auf sortierte Liste anzeigen---------------------------------------
procedure TFrmSortieren.BtnListesortiertAnzeigenClick(Sender:TObject);
var i:longint;
begin
  mmoFeldsortiert.Lines.Clear;
  for i:=0 to zufallsfelderzeuger.GibZufallsfeldlaenge-1
  do mmoFeldsortiert.lines.Add(IntToStr(sortiermaschine.GibZufallsfeld[i]));
end;

//-------- BtnListeunsortiertAnzeigenClick (published) --------------------
//----Reaktion auf unsortiere Liste anzeigen---------------------------------------
procedure TFrmSortieren.BtnListeunsortiertAnzeigenClick(Sender:TObject);
var i:longint;
begin
  mmoFeldunsortiert.Lines.Clear;
  for i:=0 to zufallsfelderzeuger.GibZufallsfeldlaenge-1
  do mmoFeldunsortiert.lines.Add(IntToStr(zufallsfelderzeuger.GibZufallsfeld[i]));
end;

//-------- BtnSortierenClick (published) ----------------------------------
//----Reaktion auf Sortierbutton---------------------------------------
procedure TFrmSortieren.BtnSortierenClick(Sender:TObject);
var
  zeitanfang,zeitende:real;
  i:longint;
begin
  BtnListeunsortiertAnzeigen.Visible:=false;
  BtnEnde.Visible:=false;
  if RBBubblesort.Checked then sortiermaschine:=bubblesortmaschine;
  if RBRippleSort.Checked then sortiermaschine:=ripplesortmaschine;
  if RBMergeSort.Checked then sortiermaschine:=mergesortmaschine;
  sortiermaschine.SetzeZufallsfeldlaenge(zufallsfelderzeuger.GibZufallsfeldlaenge);
  sortiermaschine.SetzeGrenzen(0,zufallsfelderzeuger.GibZufallsfeldlaenge-1);
  for i:=0 to zufallsfelderzeuger.GibZufallsfeldlaenge-1 do feld[i]:=zufallsfelderzeuger.GibZufallsfeld[i];
  sortiermaschine.SetzeZufallsfeld(feld);
  zeitanfang:=Time;
  sortiermaschine.sortiereZufallsfeld;
  zeitende:=Time;
  LblZeitbedarf.Caption:=FloatToStrF((Zeitende-Zeitanfang)*24*3600,ffFixed,10,2);
  BtnSortieren.Visible:=false;
  if zufallsfelderzeuger.GibZufallsfeldlaenge < 5001 then BtnListesortiertAnzeigen.Visible:=true;
  BtnEnde.Visible:=true;
end;

//-------- CBxZufallszahlenChange (published) -----------------------------
//----Reaktion auf Zufallszahlwechsel---------------------------------------
procedure TFrmSortieren.CBxZufallszahlenChange(Sender:TObject);
begin
  LblOK.Caption:='';
  MmoFeldsortiert.Clear;
  MmoFeldunsortiert.Clear;
  LblZeitbedarf.Caption:='';
  BtnListeunsortiertAnzeigen.Visible:=false;
  BtnListesortiertAnzeigen.Visible:=false;
  if StrToInt(CbxZufallszahlen.Text) >100000 then CbXZufallszahlen.Text:='1000'; 
end;

//-------- FormCreate (published) -----------------------------------------
//----Reaktion auf Programmstart---------------------------------------
procedure TFrmSortieren.FormCreate(Sender:TObject);
begin
  randomize;
  zufallsfelderzeuger:=tZufallsfelderzeuger.init;
  ripplesortmaschine:=tripplesort.init;
  bubblesortmaschine:=tbubblesort.init;
  mergesortmaschine:=tmergesort.init;
  BtnListeunsortiertAnzeigen.Visible:=false;
  BtnListesortiertAnzeigen.Visible:=false;
  BtnSortieren.Visible:=false;
end;



end.
